Subject: Re: [bitcoin-dev] Working Towards Consensus

From: Billy Tetrud <[email-masked]>
Date: Sun, 8 May 2022 12:36:01 -0500

>  it is easier to get everyone to agree when everyone has something to gain

That's unquestionably true. It doesn't really sound like what you said
originally tho.

> most users are either apathetic or trusting in the developers that
initiated it being activated. This is a dangerous dynamic to lean on

I don't disagree.

> I do not "expect" improvement by any other means than is typical in life:
competition and adaptation in response to an adverse and changing
environment.
> Why are you talking about companies and bloat while I am speaking about
being conservative?

Sounds like we agree then. However, when you said "when [designers]
speculate and lead the process, they create problems instead" I took that
to mean that you think designers shouldn't lead the process. I think
designers and engineers should lead the process, as you said, "[when] their
specialization allows them to solve a problem faster than someone else
might."

> thinking that adding complication to Bitcoin's base layer is somehow a
means of valuing simplicity

You seem to be missing my point. I am certainly not saying the words you're
putting in my mouth there. What I am saying is that a number of people have
been calling covenants for a number of years before Jeremy created CTV, and
all discussed proposals were more powerful and complex than CTV. I do think
that the design of CTV had a goal of simplicity, and I believe it achieved
that goal. If CTV were not proposed and developed, we would very likely
have seen a more complex covenant opcode on the table. I certainly would
like to see a more powerful covenant opcode myself.

> I have no reason to care about your "99%" confidence in something

I'm not asking you to care about my confidence. I'm asking to consider my
logic. Feel free to take any claims about my confidence as an aside.

> Speaking for myself, and likely the great majority of the market

... are you trying to speak for yourself, or are you trying to assert that
your opinion is the market majority opinion? If I may echo your opinion of
me, I have no reason to care about your confidence that your opinion is
everyone else's opinion as well. I'll take that as an aside ; )

> Your self-ascribed ability to assess the market is objectively
overconfident

I'm not the one claiming to speak for the market ^ I'm only relaying the
fact that the vast majority of folks I see on the dev mailing list who talk
about covenants, even occasionally, are in support of them generally, and
it seems the majority of those people who generally support covenants, if
not the vast majority, support CTV. That's what I see. Feel free to not
believe me, but the dev mailing list records are all there for you to
verify.

> That cost [of a change to bitcoin] is only offset AFTER the feature has
reached saturation of usage.

I think that's objectively false. Were it true, it would mean that every
change can only at best reach break-even, which would mean that no change
is worth doing.

> we might be too aggressive in our pace of feature speculation
> If we keep piling on features...
> Complexity can yield centralization, we should be more careful.

Are you in the "ossification now" camp, John? Or perhaps, ossification
soon? I agree that the bar of quality should continually be raised for
making changes to bitcoin, and ossification (or as near as possible) should
be the eventual goal. Perhaps we just disagree on how quickly to raise the
bar.

> However many people in the world that may want CTV, that number is surely
less than 1% of the Bitcoin user base.

I don't disagree that 1% isn't an unlikely number for the fraction of
bitcoin users who currently want specifically CTV. However, I would guess
the percentage of users who hold something close to your opinion isn't much
different from that number. Measuring things like this as a percentage of
the total bitcoin userbase is kind of worthless.

> Cry harder.
> your being offended is not important to this topic

Perhaps not, but its still no reason to act like an asshole, John. If you
think personal attacks, childish jeers, and angry dismissals will be
convincing to people who read this mailing list, you're sorely mistaken.

On Wed, May 4, 2022 at 8:01 AM LORD HIS EXCELLENCY JAMES HRMH <
[email-masked]> wrote:

> Good Afternoon,
>
> The basic principle of Bitcoin is operating the consensus fungibility. All
> transactions are published on the public ledger. What is valuable is the
> consensus as we have it, not what it may become from some proposal that may
> harm fungibility. Without consensus Bitcoin is not what is valued by the
> current consensus. Consensus is exactly why Bitcoin is fungible if that can
> be made clear. That is why it is important to defend consensus.  We have
> agreed Bitcoin has certain properties including being immutable,
> transparent, published, distributed, trustless. Consensus provides we make
> software to allow transfer of Bitcoin via ownership of a UTXO in a manner
> in accordance with consensus. If we do not value Bitcoin to defend the
> consensus we admin all kinds of features without purpose to complicate the
> operation of a wallet for a standard user. Bitcoin and the consensus is all
> about the standard user in order to be fungible. A valuable use-case does
> not approve an enhancement. Most users will never be involved in the
> consensus process and in the interest of  being fungible all developers and
> the consensus must ensure their interest in a wallet being upgraded is in
> their beneficial interest. Making a fidget toy that can do anything is not
> useful until it can make the bed, cook breakfast, and pour the coffee, that
> is, to do something useful that a user will want.
>
> One test of this is how many users will object if a feature is taken away.
>
> KING JAMES HRMH
> Great British Empire
>
> Regards,
> The Australian
> LORD HIS EXCELLENCY JAMES HRMH (& HMRH)
> of Hougun Manor & Glencoe & British Empire
> MR. Damian A. James Williamson
> Wills
>
> et al.
>
>
> Willtech
> www.willtech.com.au
> www.go-overt.com
> and other projects
>
> earn.com/willtech
> linkedin.com/in/damianwilliamson
>
>
> m. 0487135719
> f. +61261470192
>
>
> This email does not constitute a general advice. Please disregard this
> email if misdelivered.
> ------------------------------
> *From:* bitcoin-dev <[email-masked]> on
> behalf of John Carvalho via bitcoin-dev <
> [email-masked]>
> *Sent:* Monday, 2 May 2022 6:37 PM
> *To:* [email-masked] <
> [email-masked]>
> *Subject:* Re: [bitcoin-dev] Working Towards Consensus
>
> Jeremy,
>
> The path to consensus is to propose things that everyone needs. Demand
> comes from the market, not the designers.
>
> Designers (engineers) solve problems with designs, but when they speculate
> and lead the process, they create problems instead. Bitcoin is not a place
> for speculative feature additions. Bitcoin cannot afford a culture of
> additive features no one is asking for. Bitcoin thrives in a culture of
> "NO." Rejection of change is Bitcoin's primary feature.
>
> There is NO HOPE of EVER getting the majority of Bitcoin users to be able
> to grasp, audit, and meaningfully consent to complicated new features, nor
> to assess how they may interact with existing features in undesirable ways
> or affect Bitcoin's incentive structure. To ignore this is a selfish
> egomania that too many devs succumb to. The public already trusts Core devs
> more than they probably should, and it is unwise to lean on that trust.
>
> You are of course welcome to try and research and document all of the
> details about how this plays out in practice, but you will fail to specify
> a path to approval or any sort of clear governance structure for ensuring
> that speculative features get into Bitcoin. You will seek and only see a
> bias that allows you to get what YOU want. Until you focus on what everyone
> wants, you will not reach consensus on anything.
>
> Bitcoin changes should solve obvious problems and provide easy wins on
> optimization, security, and privacy. Seek simplicity and efficiency, not
> complication.
>
> We have yet to saturate usage of the features we have added already in the
> past 5 years. Use those. It is becoming apparent over time that many
> features can be accomplished off-chain, or without a blockchain, or by
> merely anchoring into currently available bitcoin transaction types.
>
> There is simply no urgency or problem that any of the proposed soft fork
> features are trying to address. This includes APO, CTV, sidechain
> proposals, etc, etc.
>
> Your aggression to your purpose is the antithesis of consensus, as it
> indicates your incentives are external to it.
>
> --
> John Carvalho
> CEO, Synonym.to <http://synonym.to/>
>
>
> On Mon, May 2, 2022 at 3:43 AM <
> [email-masked]> wrote:
>
> Send bitcoin-dev mailing list submissions to
>         [email-masked]
>
> To subscribe or unsubscribe via the World Wide Web, visit
>         https://lists.linuxfoundation.org/mailman/listinfo/bitcoin-dev
> or, via email, send a message with subject or body 'help' to
>         [email-masked]
>
> You can reach the person managing the list at
>         [email-masked]
>
> When replying, please edit your Subject line so it is more specific
> than "Re: Contents of bitcoin-dev digest..."
>
>
> Today's Topics:
>
>    1. Re: What to do when contentious soft fork activations are
>       attempted (Billy Tetrud)
>    2. Working Towards Consensus (Jeremy Rubin)
>
>
> ----------------------------------------------------------------------
>
> Message: 1
> Date: Sun, 1 May 2022 14:14:29 -0500
> From: Billy Tetrud <[email-masked]>
> To: alicexbt <[email-masked]>,  Bitcoin Protocol Discussion
>         <[email-masked]>
> Subject: Re: [bitcoin-dev] What to do when contentious soft fork
>         activations are attempted
> Message-ID:
>         <
> [email-masked]>
> Content-Type: text/plain; charset="utf-8"
>
> +1 alicexbt
>
> We of course want knowledgeable bitcoiners who aren't knowledgeable about a
> certain proposal to be skeptical. But what we don't want is for that
> natural skepticism-from-ignorance to be interpreted as opposition, or
> really a strong signal of any kind. Any thoughts from ignorance, whether
> self-aware or not, should be given small weight. It seems the vast majority
> of push back has been this kind of skepticism from ignorance. And to a
> certain degree I think we want to give time for understanding to those who
> have not participated in the first, second, third, etc round of discussion
> on a proposal. It may not be reasonable to say "you had the last 2 years of
> time to voice your concern".
>
> Now that CTV is being taken seriously as a proposal, we probably should
> give the community who is finally taking a serious look at it time to
> understand, get their questions answered, and come to terms with it. This
> is not to say that CTV as a technology or proposal has been rushed, or has
> not had enough work put into it, but rather that the community as a whole
> has not paid enough attention to it for long enough.
>
> The wrong approach is: "how do I yell more loudly next time I see something
> I'm uncomfortable with?" The right approach is to educate those who aren't
> educated on the proposal and gather consensus on what people think when
> they understand enough about it to contribute to that consensus. If you
> care about consensus, you should respect the consensus process and be ok
> with consensus being not your preferred outcome. If you don't care about
> consensus, then you're basically attacking the bitcoin community.
>
> On Sun, May 1, 2022 at 3:22 AM alicexbt via bitcoin-dev <
> [email-masked]> wrote:
>
> > Hi Michael,
> >
> > Maybe the whole thing worked as designed. Some users identified what was
> > going on, well known Bitcoin educators such as Andreas Antonopoulos,
> Jimmy
> > Song etc brought additional attention to the dangers, a URSF movement
> > started to gain momentum and those attempting a contentious soft fork
> > activation backed off. (Disappointingly Bitcoin Optech didn't cover my
> > previous posts to this mailing list 1
> > <
> https://lists.linuxfoundation.org/pipermail/bitcoin-dev/2021-October/019535.html
> >,
> > 2
> > <
> https://lists.linuxfoundation.org/pipermail/bitcoin-dev/2022-January/019728.html
> >,
> > 3
> > <
> https://lists.linuxfoundation.org/pipermail/bitcoin-dev/2022-April/020235.html
> >
> > highlighting the dangers many months ago or recent posts. Normally Optech
> > is very high signal.)
> >
> >
> > Some users have been misled and there is nothing great being achieved by
> > doing this on social media. Andreas is clueless about BIP 119 and other
> > covenant proposals. He is spreading misinformation and some of the URSF
> > enthusiasts do not understand what are they even opposing or going to run
> > with risks involved.
> >
> >
> > Answering the subject of this email: "What to do when contentious soft
> > forks activations are attempted?"
> >
> > - Do not consider something contentious because someone said it on
> mailing
> > list
> > - Do not spread misinformation
> > - Read all posts in detail with different opinions
> > - Avoid personal attacks
> > - Look at the technical details, code etc. and comment on things that
> > could be improved
> >
> >
> >
> > /dev/fd0
> >
> > Sent with ProtonMail <https://protonmail.com/> secure email.
> >
> > ------- Original Message -------
> > On Saturday, April 30th, 2022 at 3:23 PM, Michael Folkson via bitcoin-dev
> > [email-masked] wrote:
> >
> >
> > I?ve been in two minds on whether to completely move on to other topics
> or
> > to formulate some thoughts on the recent attempt to activate a
> contentious
> > soft fork. In the interests of those of us who have wasted
> > days/weeks/months of our time on this (with no personal upside) and who
> > don?t want to repeat this exercise again I thought I should at least
> raise
> > the issue for discussion of what should be done differently if this is
> > tried again in future.
> >
> > This could be Jeremy with OP_CTV at a later point (assuming it is still
> > contentious) or anyone who wants to pick up a single opcode that is not
> yet
> > activated on Bitcoin and try to get miners to signal for it bypassing
> > technical concerns from many developers, bypassing Bitcoin Core and
> > bypassing users.
> >
> > Maybe the whole thing worked as designed. Some users identified what was
> > going on, well known Bitcoin educators such as Andreas Antonopoulos,
> Jimmy
> > Song etc brought additional attention to the dangers, a URSF movement
> > started to gain momentum and those attempting a contentious soft fork
> > activation backed off. (Disappointingly Bitcoin Optech didn't cover my
> > previous posts to this mailing list 1
> > <
> https://lists.linuxfoundation.org/pipermail/bitcoin-dev/2021-October/019535.html
> >,
> > 2
> > <
> https://lists.linuxfoundation.org/pipermail/bitcoin-dev/2022-January/019728.html
> >,
> > 3
> > <
> https://lists.linuxfoundation.org/pipermail/bitcoin-dev/2022-April/020235.html
> >
> > highlighting the dangers many months ago or recent posts. Normally Optech
> > is very high signal.)
> >
> > Alternatively this was the first time a contentious soft fork activation
> > was attempted, we were all woefully unprepared for it and none of us knew
> > what we were doing.
> >
> > I?m unsure on the above. I?d be interested to hear thoughts. What I am
> > sure of is that it is totally unacceptable for one individual to bring
> the
> > entire Bitcoin network to the brink of a chain split. There has to be a
> > personal cost to that individual dissuading them from trying it again
> > otherwise they?re motivated to try it again every week/month. Perhaps the
> > personal cost that the community is now prepared if that individual tries
> > it again is sufficient. I?m not sure. Obviously Bitcoin is a
> permissionless
> > network, Bitcoin Core and other open source projects are easily forked
> and
> > no authority (I?m certainly no authority) can stop things like this
> > happening again.
> >
> > I?ll follow the responses if people have thoughts (I won't be responding
> > to the instigators of this contentious soft fork activation attempt) but
> > other than that I?d like to move on to other things than contentious soft
> > fork activations. Thanks to those who have expressed concerns publicly
> (too
> > many to name, Bob McElrath was often wording arguments better than I
> could)
> > and who were willing to engage with the URSF conversation. If an
> individual
> > can go directly to miners to get soft forks activated bypassing technical
> > concerns from many developers, bypassing Bitcoin Core and bypassing users
> > Bitcoin is fundamentally broken. The reason I still have hope that it
> isn't
> > is that during a period of general apathy some people were willing to
> stand
> > up and actively resist it.
> >
> > --
> > Michael Folkson
> > Email: michaelfolkson at protonmail.com
> > Keybase: michaelfolkson
> > PGP: 43ED C999 9F85 1D40 EAF4 9835 92D6 0159 214C FEE3
> >
> > _______________________________________________
> > bitcoin-dev mailing list
> > [email-masked]
> > https://lists.linuxfoundation.org/mailman/listinfo/bitcoin-dev
> >
> -------------- next part --------------
> An HTML attachment was scrubbed...
> URL: <
> http://lists.linuxfoundation.org/pipermail/bitcoin-dev/attachments/20220501/7158d8ed/attachment-0001.html
> >
>
> ------------------------------
>
> Message: 2
> Date: Sun, 1 May 2022 19:43:29 -0700
> From: Jeremy Rubin <[email-masked]>
> To: Bitcoin development mailing list
>         <[email-masked]>
> Subject: [bitcoin-dev] Working Towards Consensus
> Message-ID:
>         <CAD5xwhhdEgADWwLwbjRKp-UFCw9hHjDsc-L=pkiwW=
> [email-masked]>
> Content-Type: text/plain; charset="utf-8"
>
> Developers,
>
> There is much to say about the events of the last two weeks and the
> response to them. I've been searching for the right words to share here,
> but I think it best that short of a more thoughtful writeup I start with a
> timely small step with the below comments.
>
> First, let me be clear: I am not advancing a Speedy Trial(ST) activation of
> Bitcoin Improvement Proposal-119 (BIP-119) CheckTemplateVerify (CTV) at
> this time.
>
> I'm skipping any discussion of the drama here. Most of you are interested
> in developing Bitcoin, not drama. Let's try to keep this thread focused on
> the actual work. I'll make some limited comments on the drama in a separate
> thread, for those who care to hear from me on the subject directly.
>
> I believe that the disinformation spread around my post ("7 Theses on a
> next step for BIP-119"[0]) created three main negative outcomes within the
> Bitcoin community:
>
> 1. Confusion about how Bitcoin's "technical consensus" works and how
> changes are "approved".
> 2. Fear about the safety of CTV and covenants more broadly.
> 3. Misunderstandings around the properties of Speedy Trial, User Activated
> Soft Fork (UASF), User Resisted Soft Fork (URSF), Soft Forks, Hard Forks,
> and more.
>
> While I cannot take responsibility for the spread of the disinformation, I
> do apologize to anyone dealing with it for the role my actions have had in
> leading to the current circumstance.
>
> I personally take some solace in knowing that the only way out of this is
> through it. The conversations happening now seem to have been more or less
> inevitable, this has brought them to the surface, and as a technical
> community we are able to address them head on if -- as individuals and
> collectively -- we choose to. And, viewed through a certain lens, these
> conversations represent incredibly important opportunities to participate
> in defining the future of Bitcoin that would not be happening otherwise.
> Ultimately, I am grateful to live in a time where I am able to play a small
> role in such an important process. This is the work.
>
> In the coming months, I expect the discourse to be messy, but I think the
> work is clear cut that we should undertake at least the following:
>
> 1. Make great efforts to better document how Bitcoin's technical consensus
> process works today, how it can be improved, and how changes may be
> formally reviewed while still being unofficially advanced.
> 2. Work diligently to address the concerns many in the community have
> around the negative potential of covenants and better explain the
> trade-offs between levels of functionality.
> 3. Renew conversations about activation and release mechanisms and
> re-examine our priors around why Speedy Trial may have been acceptable for
> Taproot, was not acceptable for BIP-119, but may not be optimal long
> term[1], and work towards processes that better captures the Bitcoin
> network's diverse interests and requirements.
> 4. Work towards thoroughly systematizing knowledge around covenant
> technologies so that in the coming months we may work towards delivering a
> coherent pathway for the Bitcoin technical community to evaluate and put up
> for offer to the broader community an upgrade or set of upgrades to improve
> Bitcoin's capabilities for self sovereignty, privacy, scalability, and
> decentralization.
>
> This may not be the easiest path to take, but I believe that this work is
> critical to the future of Bitcoin. I welcome all reading this to share your
> thoughts with this list on how we might work towards consensus going
> forward, including any criticisms of my observations and recommendations
> above. While I would expect nothing less than passionate debate when it
> comes to Bitcoin, remember that at the end of the day we all largely share
> a mission to make the world a freer place, even if we disagree about how we
> get there.
>
> Yours truly,
>
> Jeremy
>
> [0]: https://rubin.io/bitcoin/2022/04/17/next-steps-bip119/
> [1]: http://r6.ca/blog/20210615T191422Z.html I quite enjoyed Roconnor's
> detailed post on Speedy Trial
>
> --
> @JeremyRubin <https://twitter.com/JeremyRubin>
> -------------- next part --------------
> An HTML attachment was scrubbed...
> URL: <
> http://lists.linuxfoundation.org/pipermail/bitcoin-dev/attachments/20220501/9009e65d/attachment.html
> >
>
> ------------------------------
>
> Subject: Digest Footer
>
> _______________________________________________
> bitcoin-dev mailing list
> [email-masked]
> https://lists.linuxfoundation.org/mailman/listinfo/bitcoin-dev
>
>
> ------------------------------
>
> End of bitcoin-dev Digest, Vol 84, Issue 4
> ******************************************
>
>